import java.util.*;

public abstract aspect ParentChildRelationship<Parent,Child> {
 interface ParentHasChildren<C extends ChildHasParent>{}
 interface ChildHasParent<P extends ParentHasChildren>{}
          
 declare parents: Parent implements ParentHasChildren<Child>;
 declare parents: Child implements ChildHasParent<Parent>;
          
 private List<C> ParentHasChildren<C>.children;
 private P ChildHasParent<P>.parent;
}
